# `salt-extend`

A utilty to generate extensions to the Salt source-code. This is used for :

- Adding new execution modules, state modules

- Adding unit tests to existing modules

- Adding integration tests to existing modules

## Synopsis

    salt-extend --help

## Description

`salt-extend` is a templating tool for extending SaltStack. If you're looking to add a module to SaltStack, then the `salt-extend` utility can guide you through the process.

You can use Salt Extend to quickly create templated modules for adding new behaviours to some of the module subsystems within Salt.

Salt Extend takes a template directory and merges it into a SaltStack source code directory.

See also: Salt Extend.

## Options

--extension, -e

  The extension type you want to develop, e.g. module, module_unit, state

--salt-directory, -o

  The path to the salt installation, defaults to .

--name, -n

  The module name for the new module

--description, -d

  A description of the new extension

--no-merge

  Don't merge the new module into the Salt source directory specified by --salt-directory, save to a temporary directory and print the directory path

--debug

  Print debug messages to stdout

## See also

salt-api(1) salt-call(1) salt-cloud(1) salt-cp(1) salt-key(1) salt-main(1) salt-master(1) salt-minion(1) salt-run(1) salt-ssh(1) salt-syndic(1)